# coding: utf-8

"""
    Identity Service API

    A list of identity, account and service management APIs.  # noqa: E501

    OpenAPI spec version: 1.6.5
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from idem_vra.client.vra_identity_lib.api_client import ApiClient


class PrincipalUserControllerApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_logged_in_user(self, **kwargs):  # noqa: E501
        """Get the currently logged in user.  # noqa: E501

        ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x2714;&#xFE0F; | | Service Account (Whitelisted Client) | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_logged_in_user(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param bool expand:
        :return: InlineResponse20022
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_logged_in_user_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_logged_in_user_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_logged_in_user_with_http_info(self, **kwargs):  # noqa: E501
        """Get the currently logged in user.  # noqa: E501

        ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x2714;&#xFE0F; | | Service Account (Whitelisted Client) | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_logged_in_user_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param bool expand:
        :return: InlineResponse20022
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['expand']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_logged_in_user" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'expand' in params:
            query_params.append(('expand', params['expand']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/csp/gateway/am/api/loggedin/user', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20022',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_logged_in_user_details(self, **kwargs):  # noqa: E501
        """Get the currently logged in user's detailed information.  # noqa: E501

        ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x2714;&#xFE0F; | | Service Account (Whitelisted Client) | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_logged_in_user_details(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: InlineResponse20034
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_logged_in_user_details_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_logged_in_user_details_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_logged_in_user_details_with_http_info(self, **kwargs):  # noqa: E501
        """Get the currently logged in user's detailed information.  # noqa: E501

        ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x2714;&#xFE0F; | | Service Account (Whitelisted Client) | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_logged_in_user_details_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: InlineResponse20034
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_logged_in_user_details" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/csp/gateway/am/api/loggedin/user/details', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20034',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_logged_in_user_groups_on_org(self, org_id, **kwargs):  # noqa: E501
        """Get Principal User Groups Information Within the Specified Organization  # noqa: E501

        Get Principal User Groups Information Within the Specified Organization. ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x2714;&#xFE0F; | | Service Account (Whitelisted Client) | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_logged_in_user_groups_on_org(org_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str org_id: (required)
        :return: InlineResponse20033
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_logged_in_user_groups_on_org_with_http_info(org_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_logged_in_user_groups_on_org_with_http_info(org_id, **kwargs)  # noqa: E501
            return data

    def get_logged_in_user_groups_on_org_with_http_info(self, org_id, **kwargs):  # noqa: E501
        """Get Principal User Groups Information Within the Specified Organization  # noqa: E501

        Get Principal User Groups Information Within the Specified Organization. ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x2714;&#xFE0F; | | Service Account (Whitelisted Client) | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_logged_in_user_groups_on_org_with_http_info(org_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str org_id: (required)
        :return: InlineResponse20033
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['org_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_logged_in_user_groups_on_org" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'org_id' is set
        if ('org_id' not in params or
                params['org_id'] is None):
            raise ValueError("Missing the required parameter `org_id` when calling `get_logged_in_user_groups_on_org`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'org_id' in params:
            path_params['orgId'] = params['org_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/csp/gateway/am/api/loggedin/user/orgs/{orgId}/groups', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20033',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_principal_user_profile(self, **kwargs):  # noqa: E501
        """Get the currently logged in user's profile.  # noqa: E501

        ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x2714;&#xFE0F; | | Service Account (Whitelisted Client) | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_principal_user_profile(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: InlineResponse20012
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_principal_user_profile_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_principal_user_profile_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_principal_user_profile_with_http_info(self, **kwargs):  # noqa: E501
        """Get the currently logged in user's profile.  # noqa: E501

        ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x2714;&#xFE0F; | | Service Account (Whitelisted Client) | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_principal_user_profile_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: InlineResponse20012
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_principal_user_profile" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/csp/gateway/am/api/loggedin/user/profile', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20012',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_user_default_org(self, **kwargs):  # noqa: E501
        """Get the currently logged in user's organizations.  # noqa: E501

        Currently one user can belong to exactly one organization. ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x2714;&#xFE0F; | | Service Account (Whitelisted Client) | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user_default_org(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: InlineResponse2008
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_user_default_org_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_user_default_org_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_user_default_org_with_http_info(self, **kwargs):  # noqa: E501
        """Get the currently logged in user's organizations.  # noqa: E501

        Currently one user can belong to exactly one organization. ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x2714;&#xFE0F; | | Service Account (Whitelisted Client) | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user_default_org_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: InlineResponse2008
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_user_default_org" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/csp/gateway/am/api/loggedin/user/default-org', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2008',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_user_org_info(self, org_id, **kwargs):  # noqa: E501
        """Get the currently logged in user's info in an organization.  # noqa: E501

        Currently one user can belong to exactly one organization. ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x2714;&#xFE0F; | | Service Account (Whitelisted Client) | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user_org_info(org_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str org_id: (required)
        :return: InlineResponse20019
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_user_org_info_with_http_info(org_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_user_org_info_with_http_info(org_id, **kwargs)  # noqa: E501
            return data

    def get_user_org_info_with_http_info(self, org_id, **kwargs):  # noqa: E501
        """Get the currently logged in user's info in an organization.  # noqa: E501

        Currently one user can belong to exactly one organization. ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x2714;&#xFE0F; | | Service Account (Whitelisted Client) | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user_org_info_with_http_info(org_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str org_id: (required)
        :return: InlineResponse20019
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['org_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_user_org_info" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'org_id' is set
        if ('org_id' not in params or
                params['org_id'] is None):
            raise ValueError("Missing the required parameter `org_id` when calling `get_user_org_info`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'org_id' in params:
            path_params['orgId'] = params['org_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/csp/gateway/am/api/loggedin/user/orgs/{orgId}/info', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20019',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_user_org_roles(self, org_id, **kwargs):  # noqa: E501
        """Get the currently logged in user's roles.  # noqa: E501

        ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x2714;&#xFE0F; | | Service Account (Whitelisted Client) | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user_org_roles(org_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str org_id: (required)
        :return: list[InlineResponse2006]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_user_org_roles_with_http_info(org_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_user_org_roles_with_http_info(org_id, **kwargs)  # noqa: E501
            return data

    def get_user_org_roles_with_http_info(self, org_id, **kwargs):  # noqa: E501
        """Get the currently logged in user's roles.  # noqa: E501

        ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x2714;&#xFE0F; | | Service Account (Whitelisted Client) | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user_org_roles_with_http_info(org_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str org_id: (required)
        :return: list[InlineResponse2006]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['org_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_user_org_roles" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'org_id' is set
        if ('org_id' not in params or
                params['org_id'] is None):
            raise ValueError("Missing the required parameter `org_id` when calling `get_user_org_roles`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'org_id' in params:
            path_params['orgId'] = params['org_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/csp/gateway/am/api/loggedin/user/orgs/{orgId}/roles', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[InlineResponse2006]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_user_org_service_roles(self, org_id, **kwargs):  # noqa: E501
        """Get the currently logged in user's service roles.  # noqa: E501

        ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x2714;&#xFE0F; | | Service Account (Whitelisted Client) | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user_org_service_roles(org_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str org_id: (required)
        :param str service_definition_link:
        :return: InlineResponse2005
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_user_org_service_roles_with_http_info(org_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_user_org_service_roles_with_http_info(org_id, **kwargs)  # noqa: E501
            return data

    def get_user_org_service_roles_with_http_info(self, org_id, **kwargs):  # noqa: E501
        """Get the currently logged in user's service roles.  # noqa: E501

        ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x2714;&#xFE0F; | | Service Account (Whitelisted Client) | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user_org_service_roles_with_http_info(org_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str org_id: (required)
        :param str service_definition_link:
        :return: InlineResponse2005
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['org_id', 'service_definition_link']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_user_org_service_roles" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'org_id' is set
        if ('org_id' not in params or
                params['org_id'] is None):
            raise ValueError("Missing the required parameter `org_id` when calling `get_user_org_service_roles`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'org_id' in params:
            path_params['orgId'] = params['org_id']  # noqa: E501

        query_params = []
        if 'service_definition_link' in params:
            query_params.append(('serviceDefinitionLink', params['service_definition_link']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/csp/gateway/am/api/loggedin/user/orgs/{orgId}/service-roles', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2005',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_user_orgs(self, **kwargs):  # noqa: E501
        """Get the currently logged in user's organizations.  # noqa: E501

        Currently one user can belong to exactly one organization. If expand parameter is passed, detailed information for the organizations will be returned. ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x2714;&#xFE0F; | | Service Account (Whitelisted Client) | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user_orgs(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str expand:
        :return: InlineResponse20032
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_user_orgs_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_user_orgs_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_user_orgs_with_http_info(self, **kwargs):  # noqa: E501
        """Get the currently logged in user's organizations.  # noqa: E501

        Currently one user can belong to exactly one organization. If expand parameter is passed, detailed information for the organizations will be returned. ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x2714;&#xFE0F; | | Service Account (Whitelisted Client) | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user_orgs_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str expand:
        :return: InlineResponse20032
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['expand']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_user_orgs" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'expand' in params:
            query_params.append(('expand', params['expand']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/csp/gateway/am/api/loggedin/user/orgs', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20032',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_user_preferences(self, body, **kwargs):  # noqa: E501
        """Update the currently logged in user's locale preferences.  # noqa: E501

        ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x2714;&#xFE0F; | | Service Account (Whitelisted Client) | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_user_preferences(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ProfileLocalepreferencesBody body: (required)
        :return: ProfileLocalepreferencesBody
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_user_preferences_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.update_user_preferences_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def update_user_preferences_with_http_info(self, body, **kwargs):  # noqa: E501
        """Update the currently logged in user's locale preferences.  # noqa: E501

        ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x2714;&#xFE0F; | | Service Account (Whitelisted Client) | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_user_preferences_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ProfileLocalepreferencesBody body: (required)
        :return: ProfileLocalepreferencesBody
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_user_preferences" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `update_user_preferences`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/csp/gateway/am/api/loggedin/user/profile/locale-preferences', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ProfileLocalepreferencesBody',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_user_profile(self, body, **kwargs):  # noqa: E501
        """Update the currently logged in user's profile attributes.  # noqa: E501

        ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x2714;&#xFE0F; | | Service Account (Whitelisted Client) | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_user_profile(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param UserProfileBody body: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_user_profile_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.update_user_profile_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def update_user_profile_with_http_info(self, body, **kwargs):  # noqa: E501
        """Update the currently logged in user's profile attributes.  # noqa: E501

        ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x2714;&#xFE0F; | | Service Account (Whitelisted Client) | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_user_profile_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param UserProfileBody body: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_user_profile" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `update_user_profile`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/csp/gateway/am/api/loggedin/user/profile', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
